local RepByZone = LibStub("AceAddon-3.0"):GetAddon("RepByZone")

local H = UnitFactionGroup("player") == "Horde"
local A = UnitFactionGroup("player") == "Alliance"

function RepByZone:ZoneAndFactionList()
    -- UImapID = factionID
    -- If an UImapID is not listed, that zone has no associated factionID
    -- see https://wow.gamepedia.com/UiMapID for the list of UImapIDs
    -- see https://wow.gamepedia.com/FactionID for the list of factionIDs

    local zonesAndFactions = {
        --------- Vanilla ----------
        [1]         = 46,       -- Durotar/Orgrimmar
        [3]         = 72,       -- Tiragarde Keep/Stormwind
        [4]         = 72,       -- Tiragarde Keep (Great Hall)/Stormwind
        [7]         = 81,       -- Mulgore/Thunder Bluff
        [10]        = A and 470 or H and 76, -- Northern Barrens/Ratchet or Orgrimmar
        [14]        = A and 509 or H and 510, -- Arathi Highlands/The League of Arathor or The Defilers
        [15]        = A and 47 or H and 76, -- Badlands/Ironforge or Orgrimmar
        [17]        = A and 72 or H and 76, -- Blasted Lands/Stormwind or Orgrimmar
        [18]        = 68,       -- Tirisfal Glades/Undercity
        [21]        = A and 1134 or H and 68, -- Silverpine Forest/Gilneas or Undercity
        [22]        = 1106,      -- Western Plaguelands/Argent Crusade
        [23]        = 1106,      -- Eastern Plaguelands/Argent Crusade
        [25]        = 68,       -- Hillsbrad Foothills/Undercity
        [26]        = A and 1174 or H and 530, -- Hinterlands/Wildhammer Clan or Darkspear Trolls
        [27]        = 47,       -- Dun Morogh/Ironforge
        [30]        = 54,       -- New Tinkertown/Gnomeregan
        [32]        = 59,       -- Searing Gorge/Thorium Brotherhood
        [36]        = A and 72 or H and 76, -- Burning Steppes/Stormwind or Orgrimmar
        [37]        = 72,       -- Elwynn Forest/Stormwind
        [41]        = 1090,     -- Dalaran/Kirin Tor
        [42]        = 967,      -- Deadwind Pass/The Violet Eye
        [47]        = A and 72 or H and 68, -- Duskwood/Stormwind or Undercity
        [48]        = 47,       -- Loch Modan/Ironforge
        [49]        = 72,       -- Redridge Mountains/Stormwind
        [50]        = A and 72 or H and 76, -- Northern Stranglethorn/Stormwind or Orgrimmar
        [51]        = 76,       -- Swamp of Sorrows/Orgimmar
        [52]        = 72,       -- Westfall/Stormwind
        [56]        = 47,       -- Wetlands/Ironforge
        [57]        = 69,       -- Teldrassil/Darnassus
        [62]        = 69,       -- Darkshore/Darnassus
        [63]        = A and 69 or H and 1085, -- Ashenvale/Darnassus or Warsong Offensive
        [64]        = A and 54 or H and 1133, -- Thousand Needles/Gnomeregan or Bilgewater Cartel
        [65]        = A and 69 or H and 81, -- Stonetalon Mountains/Darnassus or Thunder Bluff
        [66]        = 609,      -- Desolace/Cenarion Circle
        [69]        = A and 69 or H and 81, -- Feralas/Darnassus or Thunder Bluff
        [70]        = A and 72 or H and 76, -- Dustwallow Marsh/Stormwind or Orgrimmar
        [71]        = 369,      -- Tanaris/Gadgetzan
        [74]        = 989,      -- Timeless Tunnel/Keepers of Time
        [75]        = 989,      -- Caverns of Time/Keepers of Time
        [76]        = 1133,     -- Azshara/Bilgewater Cartel
        [77]        = A and 69 or H and 1133, -- Felwood/Darnassus or Bilgewater Cartel
        [80]        = 609,      -- Moonglade/Cenarion Circle
        [81]        = 609,      -- Silithus/Cenarion Circle
        [83]        = 577,      -- Winterspring/Everlook
        [84]        = 72,       -- Stormwind City/Stormwind
        [85]        = 76,       -- Orgrimmar/Orgrimmar
        [87]        = 47,       -- Ironforge/Ironforge
        [88]        = 81,       -- Thunder Bluff/Thunder Bluff
        [89]        = 69,       -- Darnassus/Darnassus
        [90]        = 68,       -- Undercity/Undercity

        --------- TBC ---------
        [94]        = 911,      -- Eversong Woods/Silvermoon City
        [95]        = 922,      -- Ghostlands/Tranquillien
        [97]        = 930,      -- Azuremyst Isle/Exodar
        [100]       = A and 946 or H and 947, -- Hellfire Peninsula/Honor Hold or Thrallmar
        [102]       = 942,      -- Zangarmarsh/Cenarion Expedition
        [103]       = 930,      -- The Exodar/Exodar
        [104]       = 1012,     -- Shadowmoon Valley/Ashtongue Deathsworn
        [106]       = 930,      -- Bloodmyst Isle/Exodar
        [107]       = A and 978 or H and 941, -- Nagrand/Kurenai or The Mag'har
        [108]       = 1011,     -- Terokkar Forest/Lower City
        [109]       = 933,      -- Netherstorm/The Consortium
        [110]       = 911,      -- Silvermoon City/Silvermoon City
        [111]       = 935,      -- Shattrath City/The Sha'tar
        [122]       = 1077,     -- Isle of Quel'Danas/Shattered Sun Offensive

        --------- WotLK ---------
        [114]       = A and 1050 or H and 1085, -- Borean Tundra/Valiance Expedition or Warsong Offensive
        [115]       = 1091,     -- Dragonblight/The Wyrmrest Accord
        [116]       = A and 1050 or H and 1085, -- Grizzly Hills/Valiance Expedition or Warsong Offensive
        [117]       = A and 1050 or H and 1067, -- Howling Fjord/Valiance Expedition or The Hand of Vengeance
        [118]       = 1098,     -- Icecrown/Knights of the Ebon Blade
        [119]       = self.sholazarRepID, -- See Core-Retail.lua's CheckSholazarBasin()
        [120]       = 1119,     -- The Storm Peaks/The Sons of Hodir
        [121]       = 1106,     -- Zul'Drak/Argent Crusade
        [123]       = A and 1050 or H and 1052, -- Wintergrasp/Valiance Expedition or Horde Expedition
        [124]       = 1098,     -- Plaguelands: The Scarlet Enclave (DK starting zone)/Knights of the Ebon Blade
        [125]       = 1090,     -- Dalaran City/Kirin Tor
        [126]       = 1090,     -- Dalaran City (The Underbelly)/Kirin Tor
        [127]       = 1090,     -- Crystalsong Forest/Kirin Tor
        [170]       = 1106,     -- Hrothgar's Landing/Argent Crusade
        [1360]      = 1098,     -- Icecrown Citadel (The Frozen Throne)/Knights of the Ebon Blade

        --------- Cataclysm ---------
        [174]       = 1133,     -- The Lost Isles/Bilgewater Cartel
        [179]       = 1134,     -- Gilneas/Gilneas
        [194]       = 1133,     -- Kezan/Bilgewater Cartel
        [198]       = 1158,     -- Mount Hyjal/Guardians of Hyjal
        [199]       = A and 72 or H and 76, -- Southern Barrens/Stormwind or Orgrimmar
        [201]       = 1135,     -- Kelp'thar Forest/The Earthen Ring
        [202]       = 1134,     -- Gilneas City/Gilneas
        [203]       = 1135,     -- Vashj'ir/The Earthen Ring
        [204]       = 1135,     -- Abyssal Depths/The Earthen Ring
        [205]       = 1135,     -- Shimmering Expanse/The Earthen Ring
        [207]       = 1135,     -- Deephom/The Earthen Ring
        [210]       = A and 72 or H and 76, -- The Cape of Stranglethorn/Stormwind or Orgrimmar
        [217]       = A and 1134 or H and 68, -- Ruins of Gilneas/Gilneas or Undercity
        [218]       = 1134,     -- Ruins of Gilneas City/Gilneas
        [224]       = A and 72 or H and 76, -- Stranglethorn Vale/Stormwind or Orgrimmar
        [241]       = A and 1174 or H and 1172, -- Twilight Highlands/Wildhammer Clan or Dragonmaw Clan
        [244]       = A and 1177 or H and 1178, -- Tol Barad/Baradin's Warders or Hellscream's Reach
        [245]       = A and 1177 or H and 1178, -- Tol Barad Peninsula/Baradin's Warders or Hellscream's Reach
        [249]       = 1173,     -- Uldum/Ramkahen
        [276]       = 1135,     -- The Maelstrom/The Earthen Ring
        [738]       = 1204,     -- Firelands/Avengers of Hyjal

        --------- MoP ---------
        [371]       = A and 1242 or H and 1228, -- Jade Forest/Pearlfin Jinyu or Forest Hozen
        [376]       = 1272,     -- Valley of the Four Winds/The Tillers
        [379]       = 1270,     -- Kun-Lai Summit/Shado-Pan
        [388]       = 1270,     -- Towlong Steppes/Shado-Pan
        [390]       = 1269,     -- Vale of Eternal Blossoms/Golden Lotus
        [407]       = 909,      -- Darkmoon Island (orphan)/Darkmoon Faire
        [408]       = 909,      -- Darkmoon Island (dungeon)/Darkoon Faire
        [418]       = 1302,     -- Krasarang Wilds/The Anglers
        [422]       = 1337,     -- Dread Wastes/The Klaxxi
        [425]       = 72,       -- Northshire/Stormwind
        [433]       = 1359,     -- The Veiled Stair/The Black Prince
        [507]       = A and 72 or H and 76, -- Isle of Giants/Stormwind or Orgrimmar
        [516]       = A and 1387 or H and 1388, -- Isle of Thunder/Kirin Tor Offensive or Sunreaver Onslaught
        [554]       = 1492,     -- Timeless Isle/Emperor Shaohao

        --------- WoD ---------
        [525]       = 1445,     -- Frostfire Ridge/Frostwolf Orcs
        [534]       = A and 1847 or H and 1848, -- Tanaan Jungle/Hand of the Prophet or Vol'jin's Headhunters
        [535]       = A and 1731 or H and 1445, -- Talador/Council of Exarchs or Frostwolf Orcs
        [539]       = 1731,     -- Shadowmoon Valley/Council of Exarchs
        [542]       = 1515,     -- Spires of Arak/Arakkoa Outcasts
        [543]       = A and 930 or H and 1708, -- Gorgrond/Exodar or Laughing Skull Orcs
        [550]       = 1711,     -- Nagrand/Steamwheedle Preservation Society
        [579]       = 72,       -- Lunarfall Excavation 1/Stormwind
        [580]       = 72,       -- Lunarfall Excavation 2/Stormwind
        [581]       = 72,       -- Lunarfall Excavation 3/Stormwind
        [582]       = 72,       -- Lunarfall/Stormwind
        [585]       = 76,       -- Frostwall Mine 1/Orgimmar
        [586]       = 76,       -- Frostwall Mine 2/Orgimmar
        [587]       = 76,       -- Frostwall Mine 3/Orgrimmar
        [588]       = A and 1682 or H and 1681, -- Ashran/Wrynn's Vanguard or Vol'jin's Spear
        [590]       = 76,       -- Frostwall/Orgrimmar
        [622]       = A and 1682 or H and 1681, -- Stormshield/Wrynn's Vanguard or Vol'jin's Spear

        --------- Legion ---------
        [626]       = 349,      -- Dalaran: Hall of Shadows (Rogue Class Hall)/Ravenholdt
        [627]       = 1090,     -- Dalaran City/Kirin Tor
        [628]       = 1090,     -- Dalaran: The Underbelly/Kirin Tor
        [629]       = 1090,     -- Dalran: Aegwynn's Gallery/Kirin Tor
        [630]       = 1900,     -- Azsuna/Court of Farondis
        [634]       = 1948,     -- Stormheim/Valarjar
        [641]       = 1883,     -- Val'sharah/Dreamweavers
        [646]       = 2045,     -- Broken Shore/Armies of Legionfall
        [647]       = 1098,     -- Acherus (Death Knight Class Hall)/Knights of the Ebon Blade
        [648]       = 1098,     -- Acherus (Death Knight Class Hall)/Knights of the Ebon Blade
        [650]       = 1828,     -- Highmountain/Highmountain Tribe
        [680]       = 1859,     -- Suramar/The Nightfallen
        [695]       = 1948,     -- Skyhold (Warrior Class Hall)/Valarjar
        [702]       = A and 930 or H and 68, -- Netherlight Temple (Priest Class Hall)/Exodar or Undercity
        [715]       = 609,      -- Emerald Dreamway/Cenarion Circle
        [717]       = A and 72 or H and 76, -- Dreadscar Rift (Warlock Class Hall)/Stormwind or Orgrimmar
        [718]       = A and 72 or H and 76, -- Dreadscar Rift (Warlock Class Hall)/Stormwind or Orgrimmar
        [726]       = 1135,     -- The Maelstrom/The Earthen Ring
        [734]       = 1090,     -- Hall of the Guardian (Mage Class Hall)/Kirin Tor
        [735]       = 1090,     -- The Guardian's Library (Mage Class Hall)/Kirin Tor
        [739]       = A and 69 or H and 1828, -- Trueshot Lodge (Hunter Class Hall)/Darnassus or Highmountain Tauren
        [747]       = 609,      -- The Dreamgrove/Cenarion Circle
        [750]       = 1828,     -- Thunder Totem/Highmountain Tribe
        [787]       = 609,      -- Moonglade/Cenarion Circle
        [790]       = 1894,     -- Eye of Azshara/The Wardens
        [830]       = 2170,     -- Krokuun/Argussian Reach
        [882]       = 2170,     -- Eredath (formerly Mac'Aree)/Argussian Reach
        [1474]      = 1135,     -- Heart of Azeroth (Shaman Class Hall)/The Earthen Ring

        --------- BfA ---------
        [862]       = A and 2159 or H and 2378, -- Zuldazar/7th Legion or Zandalari Empire
        [863]       = A and 2159 or H and 2380, -- Nazmir/7th Legion or Talanji's Expedition
        [864]       = A and 2159 or H and 2382, -- Vol'dun/7th Legion or Voldunai
        [895]       = A and 2160 or H and 2157, -- Tiragarde Sound/Proudmore Admiralty or The Honorbound
        [896]       = A and 2383 or H and 2157, -- Drustvar/Order of Embers or The Honorbound
        [942]       = A and 2381 or H and 2157, -- Stormsong Valley/Storm's Wake or The Honorbound
        [1161]      = A and 2160 or H and 2157, -- Borealus/Proudmore Admiralty or The Honorbound
        [1165]      = A and 2159 or H and 2378, -- Dazar'alor/7th Legion or Zandalari Empire
        [1193]      = A and 2159 or H and 2378, -- Zuldazar/7th Legion or Zandalari Empire
        [1355]      = A and 2400 or H and 2373, -- Nazjatar/Waveblade Ankoan or The Unshackled
        [1462]      = 2391,     -- Mechagon Island/Rustbolt Resistance
        [1527]      = 2417,     -- Uldum/Uldum Accord
        [1530]      = 2415,     -- Vale of Eternal Blossoms/Rajani
        [1570]      = 2415,     -- Vale of Eternal Blossoms/Rajani
        [1571]      = 2417,     -- Uldum/Uldum Accord

        --------- Shadowlands ---------
        [1525]      = 2413,     -- Revendreth/Court of Harvesters
        [1533]      = 2407,     -- Bastion/The Ascended
        [1536]      = 2410,     -- Maldraxxus/The Undying Army
        [1543]      = 2432,     -- The Maw/Ve'nari
        [1565]      = 2465,     -- Ardenweald/The Wild Hunt
        [1569]      = 2407,     -- Bastion/The Ascended
        [1603]      = 2465,     -- Ardenweald/The Wild Hunt
        [1648]      = 2432,     -- The Maw/Ve'nari
        [1670]      = self.covenantRepID, -- Ring of Fates/Covenant
        [1671]      = self.covenantRepID, -- Ring of Transference/Covenant
        [1672]      = self.covenantRepID, -- The Broker's Den/Covenant
        [1673]      = self.covenantRepID, -- The Crucible/Covenant
        [1688]      = 2413,     -- Revendreth/Court of Havesters
        [1689]      = 2410,     -- Maldraxxus/The Undying Army
        [1701]      = 2465,     -- Heart of the Forest/The Wild Hunt
        [1702]      = 2465,     -- Heart of the Forest/The Wild Hunt
        [1703]      = 2465,     -- Heart of the Forest/The Wild Hunt
        [1707]      = 2407,     -- Elysian Hold/The Ascended
        [1708]      = 2407,     -- Sanctum of Binding/The Ascended
        [1709]      = 2465,     -- Ardenweald/The Wild Hunt
        [1734]      = 2413,     -- Revendreth/Court of Harvesters
        [1738]      = 2413,     -- Revendreth/Court of Harvesters
        [1739]      = 2465,     -- Ardenweald/The Wild Hunt
        [1740]      = 2465,     -- Ardenweald/The Wild Hunt
        [1741]      = 2410,     -- Maldraxxus/The Undying Army
        [1742]      = 2413,     -- Revendreth/Court of Harvesters
        [1813]      = 2407,     -- Bastion/The Ascended
        [1814]      = 2410,     -- Maldraxxus/The Undying Army
        [1911]      = 2432,     -- Torghast: Tower of the Damned/Ve'nari
        [1960]      = 2432,     -- The Maw/Ve'nari
        [1961]      = 2470,     -- Korthia/Death's Advance
        [1970]      = 2478,     -- Zereth Mortis/The Enlightened
        [1971]      = 1948,     -- Skyhold/Valarjar
        [2005]      = 2465,     -- Ardenweald/The Wild Hunt

        --------- Dragonflight ---------
        [2022]      = 2510,     -- The Waking Shores/Valdrakken Accord
        [2023]      = 2503,     -- Ohn'ahran Plains/Maruuk Centaur
        [2024]      = 2511,     -- The Azure Span/Iskaara Tuskarr
        [2025]      = 2510,     -- Thaldraszus/Valdrakken Accord
    }
    return zonesAndFactions
end

function RepByZone:SubZonesAndFactions()
    local subZonesAndFactions = {
		-- areaID = factionID
        -- see https://wow.tools/dbc/?dbc=areatable&build=10.0.2.46801#page=1

        [35]        = 21,       -- Booty Bay/Booty Bay
        [36]        = A and 730 or H and 729, -- Alterac Mountains/Stormpike Guard or Frostwolf Clan
        [43]        = 87,       -- Wild Shore/Bloodsail Buccaneers
        [100]       = 47,       -- Nesingwary's Expedition/Ironforge
        [133]       = 54,       -- New Tinkertown/Gnomeregan
		[150]       = 72,       -- Menethil Harbor/Stormwind
        [152]       = 1106,     -- The Bulwark/Argent Crusade
        [193]       = A and 72 or H and 68, -- Ruins of Andorhal/Stormwind or Undercity
        [196]       = 72,       -- Uthor's Tomb/Stormwind
        [197]       = 72,       -- Sorrow Hill/Stormwind
        [199]       = 72,       -- Felstone Field/Stormwind
        [201]       = 68,       -- Gahrron's Withering/Undercity
        [202]       = 68,       -- Writhing Haunt/Undercity
        [204]       = 1134,     -- Pyrewood Village/Gilneas
        [233]       = 1134,     -- Ambermill/Gilneas
        [250]       = 59,       -- Ruins of Thaurissan
        [279]       = 1090,     -- Dalaran Crater/Kirin Tor
        [280]       = 349,      -- Strahnbrad/Ravenholdt
        [288]       = 72,       -- Azurelode Mine/Stormwind
		[297]       = 81,       -- Jaguero Isle/Thunder Bluff
		[299]       = 72,       -- Menethil Bay/Stormwind
        [313]       = 349,      -- Northfold Manor/Ravenholdt
        [320]       = 72,       -- Refuge Pointe/Stormwind
        [321]       = 68,       -- Hammerfall/Undercity
        [324]       = 349,      -- Stromgarde Keep/Ravenholdt
        [327]       = 21,       -- Faldir's Cove/Booty Bay
        [328]       = 21,       -- The Drowned Reef/Booty Bay
        [330]       = 47,       -- Thandol Span/Ironforge
        [350]       = 69,       -- Quel'Danil Lodge/Darnassus
		[359]       = H and 81 or A and 47, -- Bael Modan/Thunder Bluff or Ironforge
        [367]       = 530,      -- Sen'jen Village/Darkspear Trolls
        [368]       = 530,      -- Echo Isles/Darkspear Trolls
        [392]       = 470,      -- Ratchet/Ratchet
        [393]       = 530,      -- Darkspear Strand/Darkspear Trolls
        [439]       = A and 54 or H and 76, -- The Shimmering Flats/Gnomeregan or Orgrimmar
        [484]       = H and 81 or A and 69, -- Freewind Post/Thunder Bluff or Darnassus
        [501]       = 369,     -- Beezil's Wreck/Gadgetzan
        [517]       = 1358,     -- Tidefury Cove/Nat Pagle
        [530]       = 69,       -- Quel'Danil Lodge/Darnassus
		[596]       = 470,      -- Kodo Graveyard/Ratchet
        [603]       = 69,       -- Sargeron/Darnassus
        [604]       = 93,       -- Magram Village (Shok'Thokar)/Magram Clan Centaur
        [606]       = 92,       -- Gelkis Village/Gelkis Clan Centaur
        [608]       = 69,       -- Nijel's Point/Darnassus
        [609]       = 93,       -- Kolkar Village/Magram Clan Centaur
        [702]       = 69,       -- Rut'theran Village/Darnassus
        [721]       = 54,       -- Gnomeregan/Gnomeregan
        [813]       = 1106,     -- The Bulwark/Argent Crusade
        [880]       = 1174,     -- Thandol Span (Arathi Highlands)/Wildhammer Clan
        [881]       = 47,       -- Thandol Span (Wetlands)/Ironforge
        [896]       = A and 730 or H and 729, -- Purgation Isle/Stormpike Guard or Frostwolf Clan
        [987]       = 1133,     -- Land's End Beach/Bilgewater Cartel
        [989]       = 1173,     -- Ruins of Uldum/Ramkahen
        [990]       = 1173,     -- Valley of the Watchers/Ramkahen
        [1016]      = 69,       -- Direforge Hill/Darnassus
        [1025]      = 69,       -- The Green Belt/Darnassus
        [1057]      = A and 47 or H and 68, -- Thoradin's Wall (Hillsbrad Foothills)/Ironforge or Undercity
        [1216]      = 579,      -- Timbermaw Hold/Timbermaw Hold
        [1220]      = 69,       -- Darnassian Base Camp/Darnassus
        [1336]      = A and 54 or H and 1133, -- Lost Rigger Cove/Gnomeregan or Bilgewater Cartel
        [1446]      = 59,       -- Thorium Point/Thorium Brotherhood
		[1658]      = 609,      -- Cenarion Enclave/Cenarion Circle
        [1677]      = A and 730 or H and 729, -- Gavin's Naze/Stormpike Guard or Frostwolf Clan
        [1678]      = 72,       -- Sofera's Naze/Stormwind
        [1679]      = A and 730 or H and 729, -- Corrahn's Dagger/Stormpike Guard or Frostwolf Clan
        [1680]      = A and 730 or H and 729, -- The Headland/Stormpike Guard or Frostwolf Clan
		[1739]      = 1133,     -- Hardwrench Hideaway/Bilgewater Cartel
        [1741]      = 87,       -- Gurubashi Arena/Bloodsail Buccaneers
        [1757]      = 87,       -- The Crimson Veil/Bloodsail Buccaneers
        [1758]      = 87,       -- The Riptide/Bloodsail Buccaneers
        [1759]      = 87,       -- The Damsel's Luck/Bloodsail Buccaneers
        [1761]      = 579,      -- Deadwood Village/Timbermaw Hold
        [1762]      = 579,      -- Felpaw Village/Timbermaw Hold
        [1769]      = 579,      -- Timbermaw Hold/Timbermaw Hold
        [1778]      = 369,      -- Sorrowmurk/Gadgetzan
        [1797]      = 1133,     -- Stagalbog/Bilgewater Cartel
        [1857]      = A and 47 or H and 68, -- Thoradin's Wall (Arathi Highlands)/Ironforge or Undercity
		[1858]      = 1174,     -- Boulder'gor/Wildhammer Clan
        [1941]      = 989,      -- Caverns of Time/Keepers of Time
        [1998]      = 1134,     -- Talonbranch Glade/Gilneas
        [2079]      = A and 54 or H and 68, -- Alcaz Island/Gnomeregan or Undercity
		[2097]      = H and 81 or A and 69, -- Darkcloud Pinnacle/Thunder Bluff or Darnassus
		[2157]      = H and 81 or A and 47, -- Bael'dun Keep/Thunder Bluff or Ironforge
        [2177]      = 87,       -- Battle Ring/Bloodsail Buccaneers
		[2240]      = A and 54 or H and 1133, -- Mirage Raceway/Gnomeregan or Bilgewater Cartel
        [2241]      = 589,      -- Frostsaber Rock/Wintersaber Trainers
        [2242]      = 69,       -- The Hidden Grove/Darnassus
        [2243]      = 579,      -- Timbermaw Post/Timbermaw Hold
        [2244]      = 579,      -- Winterfall Village/Timbermaw Hold
        [2246]      = 579,      -- Frostfire Hot Springs/Timbermaw Hold
        [2248]      = 47,       -- Dun Mandarr/Ironforge
        [2253]      = 69,       -- Starfall Village/Darnassus
        [2257]      = 72,       -- Deeprun Tram/Stormwind
        [2300]      = 989,      -- Caverns of Time/Keepers of Time
        [2379]      = 72,       -- Azurelode Mine/Stormwind
        [2404]      = 69,       -- Tethris Aran/Darnassus
        [2406]      = 69,       -- Ranazjar Isle/Darnassus
        [2407]      = 470,      -- Kormek's Hut/Ratchet
        [2408]      = 530,      -- Shadowprey Village/Darkspear Trolls
        [2539]      = 530,      -- Malaka'jin/Darkspear Trolls
        [2597]      = A and 730 or H and 729, -- Alterac Valley/Stormpike Guard or Frostwolf Clan
        [2617]      = 470,      -- Scrabblescrew's Camp/Ratchet
        [2738]      = 69,       -- Southwind Village/Darnassus
        [2839]      = A and 730 or H and 729, -- Alterac Valley/Stormpike Guard or Frostwolf Clan
        [2897]      = 530,      -- Zoram'gar Outpost/Darkspear Trolls
        [3137]      = 69,       -- Talrendis Point/Darnassus
		[3197]      = 72,       -- Chillwind Camp/Stormwind
        [3319]      = 890,      -- Silverwing Grove/Silverwing Sentinels
        [3426]      = 69,       -- Staghelm Point/Darnassus
        [3427]      = 47,       -- Bronzebeard Encampment/Ironforge
        [3486]      = 349,      -- Ravenholdt Manor/Ravenholdt
        [4010]      = 369,      -- Mudsprocket/Gadgetzan
        [4690]      = 1135,     -- Thunder Peak/The Earthen Ring
        [4715]      = 1133,     -- The Skunkworks/Bilgewater Cartel
        [4745]      = 76,       -- Orgrimmar Rear Gate/Orgrimmar
        [4798]      = 1068,     -- Thoargad's Camp/Explorer's League
        [4803]      = 911,      -- Furien's Post/Silvermoon City
        [4882]      = 369,      -- Marshal's Stand/Gadgetzan
        [4883]      = 369,      -- Mossy Pile/Gadgetzan
        [4925]      = 609,      -- Thunk's Abode/Cenarion Circle
        [4927]      = 76,       -- The Fold/Orgimmar
        [4933]      = 76,       -- Krom'gar Fortress/Orgimmar
        [4934]      = 1133,     -- The Sludgewerks/Bilgewater Cartel
        [4940]      = 1068,     -- Northwatch Expedition Base Camp/Explorer's League
        [5011]      = 81,       -- Westreach Summit/Thunder Bluff
        [5028]      = 87,       -- Southsea Holdfast/Bloodsail Buccaneers
        [5041]      = A and 54 or H and 1133, -- Fizzle & Pozzik's Speedbarge/Gnomeregan or Bilgewater Cartel
        [5044]      = 609,      -- The Tainted Forest/Cenarion Circle
        [5048]      = A and 54 or H and 1133, -- Raceway Ruins/Gnomeregan or Bilgewater Cartel
        [5083]      = 911,      -- Sunveil Excursion/Silvermoon City
        [5117]      = 1133,     -- Nozzlepot's Outpost/Bilgewater Cartel
        [5121]      = 68,       -- Galen's Fall/Undercity
        [5305]      = 69,       -- Greenwarden's Grove/Darnassus
        [5317]      = 530,      -- Bambala/Darkspear Trolls
        [5367]      = 942,      -- The Mender's Stead/Cenarion Circle
        [5388]      = 911,      -- Dawnrise Expedition/Silvermoon City
        [5458]      = 369,      -- Bogpaddle/Gadgetzan
        [5476]      = 1134,     -- Pyrewood Chapel/Gilneas
        [5477]      = 1134,     -- Pyrewood Inn/Gilneas
        [5478]      = 1134,     -- Pyrewood Town Hall/Gilneas
        [5480]      = 1134,     -- Gilneas Liberation Base Camp/Gilneas
        [5481]      = 47,       -- 7th Legion Base Camp/Ironforge
        [5495]      = 54,       -- Gnomeregan/Gnomeregan
        [5496]      = 369,      -- Fuselight/Gadgetzan
        [5497]      = 369,      -- Fuselight-by-the-Sea/Gadgetzan
        [5524]      = 911,      -- Bloodwatcher Point/Silvermoon City
        [5564]      = 72,       -- Dragon's Mouth/Stormwind
        [5645]      = 609,      -- Whisperwind Grove/Cenarion Circle
        [5649]      = 609,      -- Wildheart Point/Cenarion Circle
        [5654]      = 59,       -- Chiselgrip/Thorium Brotherhood
        [5675]      = A and 69 or H and 81, -- Arikara's Needle/Darnassus or Thunder Bluff
        [5687]      = 1134,     -- The Howling Oak/Gilneas
        [5705]      = A and 47 or H and 530, -- Snowden Chalet/Ironforge or Darkspear Trolls
        [5706]      = 369,      -- The Steam Pools/Gadgetzan

        --------- TBC ---------
        [3482]      = 922,      -- The Dead Scar (Eversong Woods)/Tranquillien
        [3514]      = 922,      -- The Dead Scar (Ghostlands)/Tranquillien
        [3530]      = A and 930 or H and 911, -- Shadow Ridge/Exodar or Silvermoon City
        [3547]      = 1077,     -- Throne of Kil'jaeden/Shattered Sun Offensive
        [3552]      = 978,      -- Temple of Telhamat/Kurenai
        [3554]      = 911,      -- Falcon Watch/Silvermoon City
        [3555]      = 941,      -- Mag'har Post/The Mag'har
        [3569]      = 69,       -- Tides' Hollow/Darnassus
        [3573]      = 72,       -- Odesyus' Landing/Stormwind
        [3590]      = 69,       -- Wrathscale Lair/Darnassus
        [3591]      = 69,       -- Ruins of Loreth'Aran/Darnassus
        [3596]      = A and 1135, -- The Hidden Reef/The Earthen Ring
        [3598]      = 69,       -- Wyrmscar Island/Darnassus
        [3615]      = 1135,     -- Throne of the Elements/The Earthen Ring
        [3623]      = 933,      -- Aeris Landing/The Consortium
        [3636]      = 1135,     -- Elemental Plateau/The Earthen Ring
        [3673]      = 47,       -- Nesingwary Safari/Ironforge
        [3828]      = A and 930 or H and 911, -- Halaa/Exodar or Silvermoon City
        [3630]      = 933,      -- Oshu'gun/The Consortium
        [3631]      = 933,      -- Spirit Fields/The Consortium
        [3644]      = 930,      -- Telredor/Exodar
        [3645]      = 530,      -- Zabra'jin/Darkspear Trolls
        [3646]      = 970,      -- Quagg Ridge/Sporeggar
        [3647]      = 970,      -- The Spawning Glen/Sporeggar
        [3649]      = 970,      -- Sporeggar/Sporeggar
        [3652]      = 970,      -- Funggor Cavern/Sporeggar
        [3674]      = 942,      -- Cenarion Thicket/Cenarion Expedition
        [3679]      = 1031,     -- Skettis/Sha'tari Skyguard
        [3680]      = 1031,     -- Blackwind Valley/Sha'tari Skyguard
        [3681]      = 934,      -- Firewing Point/The Scryers
        [3683]      = 941,      -- Stonebreaker Hold/The Mag'har
        [3684]      = 69,       -- Allerian Stronghold/Darnassus
        [3690]      = 1031,     -- Blackwind Lake/Sha'tari Skyguard
        [3691]      = 1031,     -- Lake Ere'Noru/Sha'tari Skyguard
        [3718]      = 530,      -- Swamprat Post/Darkspear Trolls
        [3719]      = 941,      -- Bleeding Hollow Ruins/The Mag'har
        [3744]      = 76,       -- Shadowmoon Village/Orgrimmar
        [3745]      = 1174,     -- Wildhammer Stronghold/Wildhammer Clan
        [3754]      = 932,      -- Altar of Sha'tar/The Aldor
        [3758]      = 1015,     -- Netherwing Fields/Netherwing
        [3759]      = 1015,     -- Netherwing Ledge/Netherwing
        [3766]      = 978,      -- Orebor Harborage/Kurenai
        [3778]      = 1068,     -- Draenethyst Mine/Explorer's League
        [3769]      = 941,      -- Thunderlord Stronghold/The Mag'har
        [3771]      = 69,       -- The Living Grove/Darnassus
        [3772]      = 69,       -- Sylvanaar/Darnassus
        [3784]      = 1031,     -- Forge Camp: Terror/Sha'tari Skyguard
        [3785]      = 1031,     -- Forge Camp: Wrath/Sha'tari Skyguard
        [3786]      = 1038,     -- Ogri'la/Ogri'la
        [3792]      = 933,      -- Mana-Tombs/The Consortium
        [3801]      = 941,      -- Mag'har Grounds/The Mag'har
        [3806]      = 911,      -- Supply Caravan/Silvermoon City
        [3808]      = 942,      -- Cenarion Post/Cenarion Expedition
        [3816]      = 21,       -- Zeppelin Crash/Booty Bay
        [3828]      = 942,      -- Ruuan Weald/Cenarion Expedition
        [3832]      = 1038,     -- Vortex Summit/Ogri'la
        [3839]      = 1011,     -- Abandoned Armory/Lower City
        [3842]      = 935,      -- Tempest Keep (Netherstorm)/The Sha'tar
        [3864]      = 1031,     -- Bash'ir Landing/Sha'tari Skyguard
        [3896]      = 932,      -- Aldor Rise/The Aldor
        [3898]      = 934,      -- Scryer's Tier/The Scryers
        [3899]      = 1011,     -- Lower City/Lower City
        [3901]      = 69,       -- Allerian Post/Darnassus
        [3902]      = 941,      -- Stonebreaker Camp/The Mag'har
        [3918]      = 54,       -- Toshley's Station/Gnomeregan
        [3936]      = 1174,     -- Deathforge Tower/Wildhammer Clan
        [3937]      = 76,       -- Slag Watch/Orgrimmar
        [3938]      = 934,      -- Sanctum of the Stars/The Scryers
        [3951]      = 942,      -- Evergrove/Cenarion Expedition
        [3952]      = 942,      -- Wyrmskull Bridge/Cenarion Expedition
        [3958]      = 1031,     -- Sha'tari Base Camp/Sha'tari Skyguard
        [3965]      = 1015,     -- Netherwing Mines/Netherwing
        [3966]      = 1015,     -- Dragonmaw Base Camp/Netherwing
        [3964]      = 1031,     -- Skyguard Outpost/Sha'tari Skyguard
        [3973]      = 1031,     -- Blackwind Landing/Sha'tari Skyguard
        [3974]      = 1031,     -- Veil Harr'ik/Sha'tari Skyguard
        [3975]      = 1031,     -- Terokk's Rest/Sha'tari Skyguard
        [3976]      = 1031,     -- Veil Ala'rak/Sha'tari Skyguard
        [3977]      = 1031,     -- Upper Veil Shil'ak/Sha'tari Skyguard
        [3978]      = 1031,     -- Lower Veil Shil'ak/Sha'tari Skyguard
        [5554]      = 935,      -- The Mechanar Entrance/The Sha'tar
        [5555]      = 935,      -- The Botanica Entrance/The Sha'tar
        [5556]      = 935,      -- The Arcatraz Entrance/The Sha'tar
        [5776]      = 1174,     -- Wildhammer Stronghold/Wildhammer Clan

        --------- WotLK ---------
        [3987]      = 1073,     -- The Isle of Spears/The Kalu'ak
        [3988]      = 1073,     -- Kamagua/The Kalu'ak
        [3990]      = 1073,     -- Scalawag Point/The Kalu'ak
        [3997]      = 1068,     -- Explorers' League Outpost/Explorers' League
        [3999]      = 1068,     -- Steel Gate/Explorers' League
        [4018]      = 1064,     -- Camp Winterhoof/The Taunka
        [4023]      = 1090,     -- Amber Ledge/Kirin Tor
        [4024]      = 1090,     -- Coldarra/Kirin Tor
        [4033]      = 942,      -- Winterfin Village/Cenarion Expedition
        [4037]      = 1064,     -- Taunka'le Village/The Taunka
        [4040]      = 1073,     -- Njord's Breath Bay/The Kalu'ak
        [4041]      = 1073,     -- Kaskala/The Kalu'ak
        [4097]      = 942,      -- Winterfin Caverns/Cenarion Expedition
        [4099]      = 942,      -- Winterfin Retreat/Cenarion Expedition
        [4113]      = 1073,     -- Unu'pe/The Kalu'ak
        [4120]      = 1090,     -- The Nexus/Kirin Tor
        [4121]      = 1090,     -- Transitus Shield/Kirin Tor
        [4151]      = 1064,     -- Westwind Refuge Camp/The Taunka
        [4152]      = 1073,     -- Moa'ki Harbor/The Kalu'ak
        [4155]      = 1073,     -- The Half Shell/The Kalu'ak
        [4158]      = 1037,     -- Stars' Rest/Alliance Vanguard
        [4165]      = 1052,     -- Agmar's Hammer/Horde Expedition
        [4169]      = 1037,     -- Fordragon Hold/Alliance Vanguard
        [4170]      = 1052,     -- Kor'kron Vanguard/Horde Expedition
        [4171]      = A and 1037 or H and 1052, -- The Court of Skulls/Alliance Vanguard or Horde Expedition
        [4172]      = A and 1037 or H and 1052, -- Angrathar the Wrathgate/Alliance Vanguard or Horde Expedition
        [4177]      = 1037,     -- Wintergarde Keep/Alliance Vanguard
        [4178]      = 1037,     -- Wintergarde Mine/Alliance Vanguarde
        [4186]      = 1067,     -- Venomspite/The Hand of Vengeance
        [4188]      = 1037,     -- The Carrion Fields/Alliance Vanguard
        [4189]      = 942,      -- D.E.H.T.A Encampment/Cenarion Expedition
        [4190]      = 1037,     -- Thorson's Post/Alliance Vanguard
        [4191]      = 1106,     -- Light's Trust/Argent Crusade
        [4211]      = 1064,     -- Camp Oneqwah/The Taunka
        [4224]      = 1073,     -- The Briny Pinnacle/The Kalu'ak
        [4226]      = 1073,     -- Iskaal/The Kalu'ak
        [4227]      = 530,      -- Dragon's Fall/Darkspear Trolls
        [4233]      = 1106,     -- Dawn's Reach/Argent Crusade
        [4234]      = 1106,     -- Naxxramas/Argent Crusade
        [4243]      = 1037,     -- Wintergarde Crypt/Alliance Vanguard
        [4246]      = 1037,     -- Wintergarde Mausoleum/Alliance Vanguard
        [4253]      = 2159,     -- 7th Legion Front/7th Legion
        [4256]      = A and 1094 or H and 1124, -- Drak'mar Lake/The Silver Covenant or The Sunreavers
        [4261]      = 68,       -- Ghostblade Point/Undercity
        [4281]      = 1098,     -- Acherus: The Ebon Hold (Eastern Kingdoms)/Knights of the Ebon Blade
        [4284]      = 47,       -- Nesingwary Base Camp/Ironforge
        [4286]      = 1105,     -- The Bones of Nozronn/The Oracles
        [4287]      = 1104,     -- Kartak's Hold/Frenzyheart Tribe
        [4288]      = 1105,     -- Sparktouched Haven/The Oracles
        [4291]      = 1105,     -- Rainspeaker Canopy/The Oracles
        [4292]      = 1104,     -- Frenzyheart Hill/Frenzyheart Tribe
        [4297]      = 1105,     -- Mosswalker Village/The Oracles
        [4303]      = 1104,     -- Hardknuckle Clearing/Frenzyheart Tribe
        [4306]      = 1105,     -- Mistwhisper Village/The Oracles
        [4308]      = 1104,     -- Spearborn Encampment/Frenzyheart Tribe
        [4312]      = 1098,     -- Ebon Watch/Knights of the Ebon Blade
        [4369]      = 47,       -- Dorian's Outpost/Ironforge
        [4342]      = 1098,     -- Acherus: The Ebon Hold(Death Knight start)/Knights of the Ebon Blade
        [4392]      = 1105,     -- The Stormwright's Shelf/The Oracles
        [4429]      = 1085,     -- Grom'arsh Crash-Site/Warsong Offensive
        [4418]      = 21,       -- K3/Booty Bay
        [4428]      = 1126,     -- Frosthold/The Frostborn
        [4441]      = 1064,     -- Camp Tunka'lo/The Taunka
        [4442]      = 1068,     -- Brann's Base-Camp/Explorers' League
        [4458]      = 21,       -- Sparksocket Minefield/Booty Bay
        [4459]      = 21,       -- Ricket's Folly/Booty Bay
        [4479]      = A and 1094 or H and 1124, -- Winter's Breath Lake/The Silver Covenant or The Sunreavers
        [4485]      = 1126,     -- The Inventor's Library/The Frostborn
        [4487]      = 1085,     -- Frostfloe Deep/Warsong Offensive
        [4501]      = 1106,     -- The Argent Vanguard/Argent Crusade
        [4502]      = 1126,     -- Mimir's Workshop/The Frostborn
        [4503]      = A and 1094 or H and 1124, -- Ironwall Dam/The Silver Covenant or The Sunreavers
        [4504]      = 1106,     -- Valley of Echoes/Argent Crusade
        [4505]      = 1106,     -- The Breach/Argent Crusade
        [4506]      = 1106,     -- Scourgeholme/Argent Crusade
        [4507]      = A and 1037 or H and 1052, -- The Broken Front/Alliance Vanguard or Horde Expedition
        [4511]      = A and 1037 or H and 1052, -- The Skybreaker/Alliance Vanguard or Horde Expedition
        [4512]      = A and 1037 or H and 1052, -- Orgrim's Hammer/Alliance Vanguard or Horde Expedition
        [4516]      = 1106,     -- Ironwall Rampart/Argent Crusade
        [4522]      = 1156,     -- Icecrown Citadel/The Ashen Verdict
        [4536]      = A and 1068 or H and 1085, -- Frosthowl Cavern/Explorers' League or Warsong Offensive
        [4541]      = 1106,     -- Vanguard Infirmary/Argent Crusade
        [4558]      = A and 1094 or H and 1124, -- Sunreaver's Command/The Silver Covenant or The Sunreavers
        [4559]      = A and 1094 or H and 1124, -- Windrunner's Overlook/The Silver Covenant or The Sunreavers
        [4580]      = 1106,     -- Crusaders' Pinnacle/Argent Crusade
        [4593]      = 1106,     -- The Pit of Fiends/Argent Crusade
        [4616]      = A and 1094 or H and 1124, -- Sunreaver's Sanctuary/The Silver Covenant or The Sunreavers
        [4646]      = A and 1094 or H and 1124, -- Ashwood Lake/The Silver Covenant or The Sunreavers
        [4658]      = 1106,     -- Argent Tournament Grounds/Argent Crusade
        [4666]      = A and 1094 or H and 1124, -- Sunreaver Pavilion/The Silver Covenant or The Sunreavers
        [4667]      = A and 1094 or H and 1124, -- Silver Covenant Pavilion/The Silver Covenant or The Sunreavers
        [4669]      = 1106,     -- The Ring of Champions/Argent Crusade
        [4670]      = 1106,     -- The Aspirants' Ring/Argent Crusade
        [4671]      = 1106,     -- The Argent Valiants' Ring/Argent Crusade
        [4672]      = A and 1094 or H and 1124, -- The Alliance Valiants' Ring/The Silver Covenant or The Sunreavers
        [4673]      = A and 1094 or H and 1124, -- The Horde Valiants' Ring/The Silver Covenant or The Sunreavers
        [4674]      = 1106,     -- Argent Pavilion/Argent Crusade
        [4676]      = A and 1094 or H and 1124, -- Sunreaver Pavilion (Outside)/The Silver Covenant or The Sunreavers
        [4677]      = A and 1094 or H and 1124, -- Silver Covenant Pavilion (Outside)/The Silver Covenant or The Sunreavers
        [4740]      = A and 1094 or H and 1124, -- The Silver Enclave/The Silver Covenant or The Sunreavers
        [4760]      = A and 1094 or H and 1124, -- The Sea Reaver's Run/The Silver Covenant or The Sunreavers
        [5561]      = 1090,     -- The Nexus Entrance/Kirin Tor

        --------- Cataclysm ---------
        [3707]      = 72,       -- Alliance Base/Stormwind
        [3708]      = 76,       -- Horde Encampment/Orgrimmar
        [3709]      = 69,       -- Night Elf Village/Darnassus
        [4779]      = 76,       -- Horde Base Camp/Orgrimmar
        [4846]      = 81,       -- Camp Una'fe/Thunder Bluff
        [4851]      = 81,       -- Ruins of Taurajo/Thunder Bluff
        [4856]      = A and 47 or H and 81, -- Bael Modan/Ironforge or Thunder Bluff
        [4857]      = 1135,     -- Firestone Point/The Earthen Ring
        [4860]      = 81,       -- Overgrown Camp/Thunder Bluff
        [4872]      = A and 47 or H and 81, -- Bael'dun Keep/Ironforge or Thunder Bluff
        [4912]      = 76,       -- Warchief's Lookout/Orgrimmar
        [4946]      = A and 47 or H and 81, -- Bael Modan Excavation/Ironforge or Thunder Bluff
        [4947]      = 47,       -- Twinbraid's Patrol/Ironforge
        [4948]      = A and 47 or H and 1133, -- Frazzlecraz Motherlode/Ironforge or Bilgewater Cartel
        [4949]      = 81,       -- Spearhead/Thunder Bluff
        [4969]      = 72,       -- Tranquil Wash/Stormwind
        [4970]      = 76,       -- Legion's Rest/Orgrimmar
        [4975]      = 76,       -- Tenebrous Cavern/Orgrimmar
        [4976]      = 72,       -- Darkbreak Cove/Stormwind
        [4986]      = 81,       -- Vendetta Point/Thunder Bluff
        [5050]      = 1204,     -- Firelands Hatchery (The Hatchery)/Avengers of Hyjal
        [5064]      = 1204,     -- Firelands Forgeworks (The Anvil of Flame)/Avengers of Hyjal
        [5067]      = 1204,     -- The Inner Spire/Avengers of Hyjal
        [5099]      = 1204,     -- The Crucible of Flame (The Crucible)/Avengers of Hyjal
        [5137]      = 1133,     -- The Krazzworks/Bilgewater Cartel
        [5140]      = A and 72 or H and 1133, -- Highbank/Stormwind or Bilgewater Cartel
        [5155]      = 1091,     -- Vermillion Redoubt/The Wyrmrest Accord
        [5248]      = 72,       -- Voldrin's Hold/Stormwind
        [5249]      = 76,       -- Stygian Bounty/Orgrimmar
        [5293]      = 1171,     -- Crumbling Depths/Therazane
        [5294]      = 1171,     -- Shuddering Spires/Therazane
        [5295]      = 1171,     -- The Pale Roost/Therazane
        [5296]      = 1171,     -- Therazane's Throne/Therazane
        [5297]      = 1171,     -- Halcyon Egress/Therazane
        [5298]      = 1171,     -- Twilight Precipice/Therazane
        [5299]      = 1171,     -- Lorthuna's Gate/Therazane
        [5300]      = 1171,     -- Verlok Stand/Therazane
        [5302]      = 1171,     -- Crimson Expanse/Therazane
        [5338]      = 1171,     -- Fungal Deep/Therazane
        [5408]      = 1068,     -- Explorer's League Digsite/Explorer's League
        [5437]      = 1135,     -- Ring of the Elements/The Earthen Ring
        [5438]      = 1135,     -- The Maw of Madness/The Earthen Ring
        [5439]      = 1135,     -- Ruins of Drakgor/The Earthen Ring
        [5461]      = A and 72 or H and 1133, -- Dragonmaw Pass/Stormwind or Bilgewater Cartel
        [5462]      = A and 72 or H and 1133, -- Wyrms' Bend/Stormwind or Bilgewater Cartel
        [5470]      = A and 72 or H and 1133, -- Victor's Point/Stormwind or Bilgewater Cartel
        [5595]      = 1091,     -- Obsidian Forest/The Wyrmrest Accord
        [5660]      = 1091,     -- Obsidian Lair/The Wyrmrest Accord
        [5664]      = 1135,     -- Iso'rath/The Earthen Ring

        --------- MoP ---------
        [4081]      = 81,       -- The Dawnchaser/Thunder Bluff
        [5876]      = 1271,     -- Serpent's Heart/Order of the Cloud Serpent
        [5931]      = 1271,     -- The Arboretum/Order of the Cloud Serpent
        [5974]      = 1341,     -- Jade Temple Grounds/The August Celestials
        [5975]      = 1341,     -- Temple of the Jade Serpent/The August Celestials
        [5976]      = 1270,     -- Gate of the Setting Sun/Shado-Pan
        [6012]      = 1271,     -- Windward Isle/Order of the Cloud Serpent
        [6013]      = A and 1376 or H and 1375, -- The Dawnchaser (Retreat)/Operation: Shieldwall or Dominance Offensive
        [6016]      = 69,       -- Sentinel Basecamp/Darnassus
        [6022]      = 1271,     -- Mistveil Sea/Order of the Cloud Serpent
        [6025]      = 47,       -- Nesingwary's Safari/Ironforge
        [6048]      = 1341,     -- Temple of the Red Crane/The August Celestials
        [6059]      = A and 1353 or H and 1352, -- Binan Village/Tushui Pandaren or Huojin Pandaren
        [6080]      = 1271,     -- Serpent's Overlook/Order of the Cloud Serpent
        [6117]      = 1341,     -- Fountain of the Everseeing/The August Celestials
        [6118]      = 1341,     -- The Scrollkeeper's Sanctum/The August Celestials
        [6119]      = 1341,     -- Terrace of the Twin Dragons/The August Celestials
        [6120]      = 1341,     -- The Heart of Jade/The August Celestials
        [6143]      = 1341,     -- Mogu'shan Palace1/The August Celestials
        [6155]      = 1341,     -- Cradle of Chi-Ji/The August Celestials
        [6160]      = 1341,     -- Angkhal Pavilion/The August Celestials
        [6161]      = 1341,     -- Pedestal of Hope/The August Celestials
        [6162]      = 1341,     -- Dome Balrissa/The August Celestials
        [6174]      = 1341,     -- Temple of the White Tiger/The August Celestials
        [6182]      = 1341,     -- Mogu'shan Palace2/The August Celestials
        [6213]      = 1341,     -- Niuzao Temple/The August Celestials
        [6295]      = 1345,     -- Seat of Knowledge/The Lorewalkers
        [6368]      = 1302,     -- Soggy's Gamble/The Anglers
        [6371]      = A and 1376 or H and 1375, -- The Southern Isles/Operation: Shieldwall or Dominance Offensive
        [6393]      = 1270,     -- Serpent's Spine (Valley of the Four Winds)/Shado-Pan
        [6394]      = 1270,     -- Serpent's Spine (Vale of Eternal Blossoms)/Shado-Pan
        [6395]      = 1270,     -- Serpent's Spine (Kun-Lai Summit)/Shado-Pan
        [6401]      = 1302,     -- Shelf of Mazu/The Anglers
        [6402]      = 1302,     -- Wreck of the Mist-Hopper/The Anglers
        [6433]      = 1302,     -- Lonesome Cove/The Anglers
        [6482]      = A and 1341, -- The Summer Terrace/The August Celestials
        [6498]      = 1341,     -- Gate of the August Celestials/The August Celestials
        [6512]      = 1271,     -- The Widow's Wail/Order of the Cloud Serpent
        [6513]      = 1271,     -- Oona Kagu/Order of the Cloud Serpent
        [6533]      = 72,       -- The Skyfire (Jade Forest)/Stormwind
        [6560]      = H and 1341, -- The Golden Terrace/The August Celestials
        [6566]      = A and 1376 or H and 1375, -- Domination Point/Operation: Shieldwall or Dominance Offensive
        [6595]      = A and 1376 or H and 1375, -- The Skyfire/Operation: Shieldwall or Dominance Offensive
        [6596]      = A and 1376 or H and 1375, -- Lion's Landing1/Operation: Shieldwall or Dominance Offensive
        [6597]      = A and 1376 or H and 1375, -- Sparkrocket Outpost/Operation: Shieldwall or Dominance Offensive
        [6600]      = A and 1376 or H and 1375, -- Blacksand Spillway/Operation: Shieldwall or Dominance Offensive
        [6601]      = A and 1376 or H and 1375, -- Bilgewater Beach/Operation: Shieldwall or Dominance Offensive
        [6602]      = A and 1376 or H and 1375, -- The Boiling Crustacean/Operation: Shieldwall or Dominance Offensive
        [6604]      = A and 1376 or H and 1375, -- Quickchop's Lumber Farm/Operation: Shieldwall or Dominance Offensive
        [6609]      = A and 1376 or H and 1375, -- Ruins of Ogudei/Operation: Shieldwall or Dominance Offensive
        [6643]      = A and 1376 or H and 1375, -- Lion's Landing/Operation: Shieldwall or Dominance Offensive
        [6644]      = A and 1376 or H and 1375, -- Domination Point (Horde)/Operation: Shieldwall or Dominance Offensive
        [6701]      = 54,       -- Beeble's Wreck/Gnomeregan
        [6702]      = 1133,     -- Bozzle's Wreck/Bilgewater Cartel
        [6762]      = 1710,     -- Shattrath City Center/Sha'tari Defense
        [6771]      = 1341,     -- Celestial Tournament/The August Celestials

        ---------- WoD ----------
        [6926]      = 1515,     -- Veil Shadar/Arakkoa Outcasts
        [6933]      = 1515,     -- Terokkar Refuge/Arakkoa Outcasts
        [6999]      = 946,      -- Admiral Taylor's Garrison/Honor Hold
        [7032]      = 1710,     -- Garden of K'ure/Sha'tari Defense
        [7060]      = 47,       -- Hemet's Happy Hunting Grounds/Ironforge
        [7061]      = 930,      -- Yrel's Watch/Exodar
        [7063]      = 81,       -- Riverside Post/Thunder Bluff
        [7072]      = 889,      -- Ancestral Grounds/Warsong Outriders
        [7074]      = 930,      -- Telaar/Exodar
        [7081]      = 930,      -- Telaari Station/Exodar
        [7139]      = 1135,     -- Elemental Plateau/The Earthen Ring
        [7141]      = 1710,     -- Arch of Sha'tar/Sha'tari Defense
        [7156]      = 889,      -- Anguish Point/Warsong Outriders
        [7162]      = 1711,     -- Pinchwhistle Gearworks/Steamwheedle Preservation Society
        [7163]      = 1711,     -- Pinchwhistle Point/Steamwheedle Preservation Society
        [7164]      = 1711,     -- Wreck of the Mother Lode/Steamwheedle Preservation Society
        [7197]      = 76,       -- Axefall/Orgrimmar
        [7198]      = 72,       -- Southport/Stormwind
        [7208]      = 946,      -- The Briny Barnacle/Honor Hold
        [7222]      = 946,      -- Admiral Taylor's Farm/Honor Hold
        [7266]      = 1711,     -- The Rusty Cylinder/Steamwheedle Preservation Society
        [7269]      = 1710,     -- Spire of Light/Sha'tari Defense
        [7295]      = 930,      -- Telaari Tankworks/Exodar
        [7377]      = 2135,     -- Time-Lost Glade/Chromie
        [7389]      = 1710,     -- Bladefury's Command/Sha'tari Defense
        [7391]      = 1710,     -- The Path of Glory/Sha'tari Defense
        [7392]      = 1731,     -- Pillars of Fate/Council of Exarchs
        [7417]      = 1710,     -- Sha'tari Anchorage/Sha'tari Defense
        [7418]      = 1710,     -- Shattrath Port Authority/Sha'tari Defense
        [7419]      = 1710,     -- Beacon of Sha'tar/Sha'tari Defense
        [7420]      = 1710,     -- Shattrath City/Sha'tari Defense
        [7421]      = 1710,     -- Shattrath Commons/Sha'tari Defense
        [7422]      = 1710,     -- Sha'tari Market District/Sha'tari Defense
        [7433]      = 930,      -- Telaari Worksite/Exodar
        [7453]      = 1710,     -- Sha'tar Way Station/Sha'tari Defense
        [7454]      = 1710,     -- Sha'tari Skymesa/Sha'tari Defense
        [7455]      = 1710,     -- Shattrath Residential District/Sha'tari Defense
        [7480]      = 1710,     -- Shattrath Overlook/Sha'tari Defense
        [7484]      = 72,       -- Southport Worksite/Stormwind
        [7536]      = 1515,     -- Aktar's Post/Arakkoa Outcasts
        [7641]      = 1850,     -- Fang'rila/The Saberstalkers
        [7655]      = A and 1710 or H and 1708, -- Rangari Refuge/Sha'tari Defense or Laughing Skull Orcs
        [7739]      = 1850,     -- Blackfang Challenge Arena/The Saberstalkers

        --------- Legion ---------
        [7342]      = 68,       -- Queen's Reprisal/Undercity
        [7542]      = A and 1134 or H and 68, -- Weeping Bluffs/Gilneas or Undercity
        [7555]      = A and 1134 or H and 68, -- Skyfire Triage Camp/Gilneas or Undercity
        [7563]      = A and 1134 or H and 68, -- Cove of Nashal/Gilneas or Undercity
        [7564]      = A and 1134 or H and 68, -- Forsaken Foothold/Gilneas or Undercity
        [7638]      = 1106,     -- Sanctum of Light (Paladin Class Hall)/Argent Crusade
        [7642]      = 1134,     -- Bradensbrook/Gilneas
        [7650]      = 1134,     -- Marl's Stead/Gilneas
        [7679]      = 1098,     -- Acherus: The Ebon Hold (Broken Isles)/Knights of the Ebon Blade
        [7698]      = A and 1134 or H and 68, -- Dreadwake's Landing/Gilneas or Undercity
        [7699]      = A and 1134 or H and 68, -- Greywatch/Gilneas or Undercity
        [7700]      = A and 1134 or H and 68, -- Ranger's Foothold/Gilneas or Undercity
        [7701]      = 1134,     -- Crowley's Overlook/Gilneas
        [7733]      = 47,       -- Nesingwary's Retreat/Ironforge
        [7743]      = 1098,     -- Acherus: The Ebon Hold (Icecrown)/Knights of the Ebon Blade
        [7773]      = A and 1134 or H and 68, -- Greymane's Offensive/Gilneas or Undercity
        [7778]      = 1134,     -- Heathrow Manor/Gilneas
        [7779]      = 1134,     -- Radcliffe Landing/Gilneas
        [7787]      = 1894,     -- Vault of the Wardens/The Wardens
        [7789]      = A and 1134 or H and 68, -- Bronzeleaf Thicket/Gilneas or Undercity
        [7813]      = 1948,     -- Skyhold (Warrior)/Valarjar
        [7814]      = 1894,     -- Vault of the Wardens (Demon Hunter)/The Wardens
        [7849]      = A and 1134 or H and 68, -- Cullen's Post/Gilneas or Undercity
        [7850]      = A and 1134 or H and 68, -- Lorna's Watch/Gilneas or Undercity
        [7879]      = 1090,     -- Hall of the Guardian (Mage Class Hall)/Kirin Tor
        [7903]      = 1341,     -- Temple of Five Dawns (Monk)/The August Celestials
        [7904]      = 1341,     -- Shrine of Five Dawns (Monk)/The August Celestials
        [8051]      = A and 1134 or H and 68, -- Cordana's Apex/Gilneas or Undercity
        [8078]      = A and 1134 or H and 68, -- Nightwatcher's Perch/Gilneas or Undercity
        [8147]      = 1894,     -- Isle of the Watchers/The Wardens
        [8237]      = select(2, UnitClass("player")) == "SHAMAN" and 1135, -- Alluvanon's Delta/The Earthen Ring
        [8270]      = 1975,     -- Margoss's Retreat/Conjurer Margoss
        [8273]      = 1134,     -- Thorton's Cottage/Gilneas
        [8284]      = A and 69 or H and 911, -- Illidari Redoubt/Darnassus or Silvermoon City
        [8300]      = A and 1134 or H and 68, -- Theodric's Lodge/Gilneas or Undercity
        [8301]      = A and 1134 or H and 68, -- Greywatch Barracks/Gilneas or Undercity
        [8302]      = A and 1134 or H and 68, -- The Oblivion/Gilneas or Undercity
        [8304]      = A and 1134 or H and 68, -- Starstalker's Point/Gilneas or Undercity
        [8320]      = A and 1134 or H and 68, -- Darkfollow's Spire/Gilneas or Undercity
        [8324]      = A and 1134 or H and 68, -- Whisperwind's Citadel
        [8328]      = A and 1134 or H and 68, -- Blackhawk's Bulwark/Gilneas or Undercity
        [8370]      = 1894,     -- Watchers' Aerie/The Wardens
        [8371]      = 1894,     -- Wardens' Redoubt/The Wardens
        [8394]      = 1134,     -- Carlisle Cottage/Gilneas

        --------- BfA ---------
        [8925]      = 47,       -- Nesingwary's Trek/Ironforge
        [9310]      = 2386,     -- The Wound/Champions of Azeroth
        [9329]      = 2387,     -- Seeker's Outpost/Tortollan Seekers
        [9470]      = 2395,     -- Mildenhall Brewery/Honeyback Hive
        [9473]      = 69,       -- Staghelm Point/Darnassus
        [9474]      = 1133,     -- Southwind Village/Bilgewater Cartel
        [9494]      = 1133,     -- Warfront: The Battle for Stromgarde (Ar'gorok)/Bilgewater Cartel
        [9556]      = 2387,     -- Tortaka Refuge/Tortollan Seekers
        [9667]      = 2386,     -- Chamber of Heart (Destroyed)/Champions of Azeroth
        [9693]      = 2387,     -- Seeker's Vista/Tortollan Seekers
        [9714]      = 2387,     -- Seeker's Expedition/Tortollan Seekers
        [9735]      = 1133,     -- Ar'gorok/Bilgewater Cartel
        [9747]      = 72,       -- Warfront: The Battle for Stromgarde (Refuge Pointe)/Stormwind
        [9750]      = 68,       -- Hammerfall/Undercity
        [9755]      = 47,       -- Thandol Span/Ironforge
        [9756]      = 68,       -- Thoradin's Wall (Horde Warfront)/Undercity
        [9758]      = 47,       -- Thoradin's Wall (Alliance Warfront)/Ironforge
        [6759]      = A and 47 or H and 68, -- Thoradin's Wall/Ironforge or Undercity
        [10006]     = 2387,     -- House of Jol/Tortollan Seekers
        [10504]     = 2386,     -- Chamber of Heart (rebuilt)/Champions of Azeroth
        [12905]     = 2386,     -- Chamber of Heart (scenario)/Champions of Azeroth
        [13539]     = 1098,     -- Acherus: The Ebon Hold (Class Hall)/Knights of the Ebon Blade

        --------- Shadowlands ---------
        [10565]     = self.covenantRepID, -- Oribos/Covenant
        [10979]     = 2413,     -- Darkhaven/Court of Harvesters
        [10995]     = 2439,     -- Halls of Atonement/The Avowed
        [11533]     = self.covenantRepID == 3 and 2422 or 2465, -- Tirna Noch/Night Fae or The Wild Hunt
        [12796]     = 2462,     -- The Stitchyard/Stitchmasters
        [12876]     = self.covenantRepID == 4 and 2410 or 2410, -- Seat of the Primus/The Undying Army
        [12901]     = 2462,     -- Etheric Vault/Stitchmasters
        [13209]     = self.covenantRepID, -- Netherhollow (Oribos)/Covenant
        [13346]     = 2462,     -- Body Banks/Stitchmasters
        [13347]     = 2462,     -- Thread House/Stitchmasters
        [13348]     = 2462,     -- Amputory/Stitchmasters
        [13367]     = self.covenantRepID == 3 and 2422 or 2465, -- Queen's Conservatory/Night Fae or The Wild Hunt
        [13414]     = 2413,     -- The Sinposium/Court of Harvesters
        [13498]     = self.covenantRepID, -- Ring of Transference (Oribos)/Covenant
        [13499]     = self.covenantRepID, -- Ring of Fates (Oribos)/Covenant
        [13515]     = 2407,     -- Seat of the Archon: Font of Fealty/The Ascended
        [13555]     = 2462,     -- Sixfold Recluse/Stitchmasters
        [13625]     = 2472,     -- Keeper's Respite/The Archivists' Codex
        [13652]     = 2472,     -- Reliquarty of Rememberance/The Archivists' Codex
        [13691]     = 2472,     -- Chamber of Knowledge/The Archivists' Codex
        [13692]     = 2472,     -- Chamber of Wisdom/The Archivists' Codex

        --------- Dragonflight ---------
        [13587]     = 2526,     -- Winterpelt Hollow/Winterpelt Furbolg
        [13725]     = 2507,     -- Life Vault Ruins/Dragonscale Expedition
        [13729]     = 2507,     -- Crumbling Life Archway/Dragonscale Expedition
        [13732]     = 2507,     -- Dragonscale Basecamp/Dragonscale Expedition
        [13733]     = 2507,     -- Wild Preserve/Dragonscale Expedition
        [13739]     = 2517,     -- Obsidian Bulwark/Wrathion
        [13782]     = 2520,     -- Nokhudon Hold/Clan Nokhud
        [13939]     = 2507,     -- Wingrest Embassy/Dragonscale Expedition
        [13941]     = 2517,     -- Obsidian Throne/Wrathion
        [14054]     = 2520,     -- The Nokhud Approach/Clan Nokhud
    }
    return subZonesAndFactions
end